/*
Copyright 2019 The Vitess Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package events

import (
	base "vitess.io/vitess/go/vt/events"
)

// SplitClone is an event that describes a single step in a horizontal
// split clone.
type SplitClone struct {
	base.StatusUpdater

	Keyspace, Shard, Cell string
	ExcludeTables         []string
}

// VerticalSplitClone is an event that describes a single step in a vertical
// split clone.
type VerticalSplitClone struct {
	base.StatusUpdater

	Keyspace, Shard, Cell string
	Tables                []string
}
