/*
Copyright 2020 The Vitess Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Package yaml2 ensures that the right yaml package gets imported.
// The default package that goimports adds is not the one we want to use.
package yaml2

import "sigs.k8s.io/yaml"

var (
	// Marshal marshals to YAML.
	Marshal = yaml.Marshal
	// Unmarshal unmarshals from YAML.
	Unmarshal = yaml.Unmarshal
)
